#pragma once

#include <QObject>
#include <QQmlContext>
#include <vector>

class MatrixCore;

class AppCore : public QObject {
    Q_OBJECT
    Q_PROPERTY(QVariantList accounts READ getAccounts NOTIFY accountChange)
public:
    Q_INVOKABLE void addAccount(QString profileName = "");

    Q_INVOKABLE void switchAccount(QString profileName);

    Q_INVOKABLE QVariantList getAccounts();

    QList<MatrixCore*> accounts;

    QQmlContext* context = nullptr;

signals:
    void accountChange();
};
