#pragma once

#include <QApplication>
#include <QSystemTrayIcon>

class Desktop : public QObject {
    Q_OBJECT
public:
    Q_INVOKABLE void showTrayIcon(const bool shouldHide) {
        QApplication::setQuitOnLastWindowClosed(shouldHide);

        if (shouldHide)
            icon->show();
        else
            icon->hide();
    }

    Q_INVOKABLE void showMessage(const QString title, const QString content) {
        icon->showMessage(title, content);
    }

    Q_INVOKABLE bool isTrayIconEnabled() {
        return icon->isVisible();
    }

    QSystemTrayIcon* icon;
};
