import QtQuick 2.15
import QtGraphicalEffects 1.0
import QtQuick.Controls 2.3

Item {
    property var source: String

    Image {
        id: image

        cache: true

        width: parent.width
        height: parent.height

        sourceSize.width: parent.width
        sourceSize.height: parent.height

        source: parent.source

        layer.enabled: true
        layer.effect: OpacityMask {
            maskSource: Item {
                width: image.width
                height: image.height
                Rectangle {
                    anchors.centerIn: parent
                    width: image.width
                    height: image.height
                    radius: Math.min(width, height)
                }
            }
        }
    }
}

